unit FLoadCustomFunctions;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, IdBaseComponent, IdComponent, IdTCPConnection, IdTCPClient,
  IdHTTP, IdIOHandler, IdIOHandlerSocket, IdIOHandlerStack, IdSSL,
  IdSSLOpenSSL, IdSSLOpenSSLHeaders, StdCtrls, IdGlobal;

type
  TFRMLoadCustomFunctions = class(TForm)
    IdHTTP1: TIdHTTP;
    btnGoTo: TButton;
    txtURL: TEdit;
    cboOpenSSLAPI: TComboBox;
    Label1: TLabel;
    memoLog: TMemo;
    IdSSLIOHandlerSocketOpenSSL1: TIdSSLIOHandlerSocketOpenSSL;
    procedure btnGoToClick(Sender: TObject);
  private

  public
    { Public declarations }
  end;

var
  FRMLoadCustomFunctions: TFRMLoadCustomFunctions;

implementation

const
  CS_OPENSSL_VERSION      = 0;
  CS_OPENSSL_CFLAGS       = 1;
  CS_OPENSSL_BUILT_ON     = 2;
  CS_OPENSSL_PLATFORM     = 3;
  CS_OPENSSL_DIR          = 4;
  CS_OPENSSL_ENGINES_DIR  = 5;

var
  OpenSSL_version : function(t: Integer): PIdAnsiChar; cdecl = nil;

{$R *.dfm}
procedure DoOpenSSLLoadFuncsCallback(hIdSSL: TIdLibHandle; hIdCrypto:
    TIdLibHandle; const FailedLoadList: TStringList);
begin
  @OpenSSL_version := LoadLibFunction(hIdCrypto, 'OpenSSL_version');
end;

procedure DoOpenSSLUnLoadFuncsCallback;
begin
  @OpenSSL_version := nil;
end;

procedure TFRMLoadCustomFunctions.btnGoToClick(Sender: TObject);
var
  oStream: TStringStream;
begin
  case cboOpenSSLAPI.ItemIndex of
    0:
      begin
        IdSSLIOHandlerSocketOpenSSL1.SSLOptions.APIVersion := sslvAPI_1_1;
        IdSSLIOHandlerSocketOpenSSL1.SSLOptions.Method := sslvTLSv1_2;
      end;
    1:
      begin
        IdSSLIOHandlerSocketOpenSSL1.SSLOptions.Method := sslvTLSv1_3;
        IdSSLIOHandlerSocketOpenSSL1.SSLOptions.APIVersion := sslvAPI_3_0;
      end;
  end;

  IdOpenSSLSetLoadFuncsCallback(DoOpenSSLLoadFuncsCallback);
  IdOpenSSLSetUnLoadFuncsCallback(DoOpenSSLUnLoadFuncsCallback);

  oStream := TStringStream.Create('');
  Try
    IdHTTP1.Get(txtURL.Text, oStream);

    // custom openssl function
    memoLog.Lines.Add(OpenSSL_version(CS_OPENSSL_VERSION));
    memoLog.Lines.Add(OpenSSL_version(CS_OPENSSL_CFLAGS));
    memoLog.Lines.Add(OpenSSL_version(CS_OPENSSL_BUILT_ON));
    memoLog.Lines.Add(OpenSSL_version(CS_OPENSSL_PLATFORM));
    memoLog.Lines.Add(OpenSSL_version(CS_OPENSSL_DIR));
    memoLog.Lines.Add(OpenSSL_version(CS_OPENSSL_ENGINES_DIR));

    btnGoTo.Enabled := False;
  Finally
    FreeAndNil(oStream);
  End;
end;

end.
